<?php

function CreditAmount( $itemPrice, $creditValue )
{
	$result = 0;
	
	// is it a percentage?
	if ( $creditValue < 0 ) $result = round( ($itemPrice / 100.0 ) * abs($creditValue));
	else $result = $creditValue;
	
	return $result;
}

function CleanGet()
{
	if( !get_magic_quotes_gpc() )
	{
		$_GET = array_map('mysql_real_escape_string', $_GET);
	} 
	else 
	{
		$_GET = array_map('stripslashes', $_GET);
		$_GET = array_map('mysql_real_escape_string', $_GET);        
	}  
}


// ----------------------------------------------


// we'll first attempt to verify that this request is coming from SLM
$ansHash = $_SERVER['HTTP_X_ANS_VERIFY_HASH'];
if ( strlen($ansHash) != 40 )
{
  exit;
}

  
// since we made it this far ...
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

DBConnect();
CleanGet();

// grab the owner's key
$ownerKey = $_GET['MerchantKey'];

// we need the store id to get the user's salt
$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	exit;
}

$sql = "SELECT salt,pricemode,credit FROM slm WHERE storeid=$storeID";
$result = run_mysql_query( $sql );
if ( mysql_num_rows($result) != 1 )
{
  exit;
}

$row = mysql_fetch_assoc($result);
$salt = $row['salt'];
$priceMode = $row['pricemode'];
$credit = $row['credit'];


// check that the request is valid
$myHash = sha1($_SERVER['QUERY_STRING'] . $salt);

if ( $ansHash != $myHash )
{
  exit;
}

// grab the fields we're interested in...
$custKey = $_GET['PayerKey'];
$custName = rawurldecode( $_GET['PayerName'] );
$recipKey = $_GET['ReceiverKey'];
$recipName = rawurldecode( $_GET['ReceiverName'] );

// SLM sends the payer's name/uuid in the receiver field. We'll only record
// these values if they're NOT the payer
if ( $recipKey == $custKey )
{
	$recipName = '';
	$recipKey = '';
}

$item = rawurldecode( $_GET['InventoryName'] );

// calculate the cost and the reward
$cost = CleanIntGet('PaymentGross');
if ( $priceMode == 'B' )
  $cost -= CleanIntGet( 'PaymentFee' );

if ( $cost <= 0 )
{
  exit;
}
	
$reward = CreditAmount( $cost, $credit );	

// use PHP dates 
$date = time();
	
// record the transaction
$sql = <<<SQL
INSERT INTO sales 
 VALUES (0, $storeID, "SLM", $date, "$custKey", "$custName", "$item", "L", $cost, $reward, "$recipKey", "$recipName")
SQL;

$result = run_mysql_query( $sql );


if ( $result && $reward > 0 )
{
	AddCredit( $custKey, $custName, $storeID, $reward );
}
