<?php

// reply fields
define('FIELD_STATUS', '_status');
define('FIELD_ERROR', '_error');
define('FIELD_METHOD', '_method');
define('FIELD_BALANCE', '_balance');
define('FIELD_REWARDED', '_rewarded');
define('FIELD_CUSTKEY', '_custkey');
define('FIELD_UUID', '_uuid');
define('FIELD_DATE', '_date');
define('FIELD_LOCATION', '_loc');
define('FIELD_STOREID', '_sid');
define('FIELD_STOREINFO', '_sinfo');
define('FIELD_PASSWORD', '_pw');

define('FIELD_URL', '_url');
define('FIELD_URL_MAIN', '_urlmain');			 // for geturl2
define('FIELD_URL_BACKUP', '_urlbackup');  // for geturl2


// response values
define('STATUS_OK', 'ok');  // success
define('STATUS_INS', 'ins');  // insufficient credit
define('STATUS_ERR', 'err'); // server-side error
define('STATUS_NOTFOUND', 'nf'); // requested info not found
define('STATUS_REG', 'ar'); // already registered

define('DATE_FORMAT', 'n/j/Y g:ia');
define('SMALL_DATE_FORMAT', 'n/j/Y');

// date_default_timezone_set('America/Los_Angeles');

/*

define('REPLY_ID', 'id');
define('REPLY_KEY', 'key');
define('REPLY_FIELD', 'errfield');
define('REPLY_POINTS', 'points');

define('REPLY_PASSWORD', '_password');
define('REPLY_STOREID', '_storeid');
define('REPLY_REMAINING', 'remaining');
define('REPLY_SLURL', 'slurl');
define('REPLY_URL', 'url');
define('REPLY_THANKS', '_thankyou');
define('REPLY_FOLDERS', 'folders');
define('REPLY_GIFTNOTICE', '_giftnotice');
define('REPLY_LSCOUNT', '_lscount');
define('REPLY_SALE', 'sale');
define('REPLY_TOTAL', '_total');
define('REPLY_ACTION', '_action');

define('STATUS_REG', 'reg');  // registered
define('STATUS_INV', 'inv');  // invalid arguments
*/


function EXEReply($arr)
{
	$s = '';
	foreach ( $arr as $key => $value )
		$s = $s . $key . '=' . $value . "\n";
	print $s;
}

function LSLReply($arr)
{
	$s = '';
	foreach ( $arr as $key => $value )
		$s = $s . $key . '=' . $value . '&';
	print trim( $s, '&' );
}

function E2VError( $reason )
{
	LSLReply( array( FIELD_ERROR => $reason ) );
}

function E2VSuccess()
{
	LSLReply( array(FIELD_STATUS => REPLY_OK ) );
}

function CleanPost()
{
	if( !get_magic_quotes_gpc() )
	{
		$_POST = array_map('mysql_real_escape_string', $_POST);
	} 
	else 
	{
		$_POST = array_map('stripslashes', $_POST);
		$_POST = array_map('mysql_real_escape_string', $_POST);        
	}  
}

// cleaning integers
$std_int_filter = array(
	'flags' 	=> FILTER_REQUIRE_SCALAR,
	'options' 	=> array(
		'min_range' => 0,
		'default' => 0
		)
	);

function CleanInt( $post_key )
{
  global $std_int_filter;
	$v = $_POST[ $post_key ];
	if ( !isset($v) ) return 0;
	else return filter_var($v, FILTER_VALIDATE_INT, $std_int_filter);
}

function CleanIntGet( $get_key )
{
  global $std_int_filter;
	$v = $_GET[ $get_key ];
	if ( !isset($v) ) return 0;
	else return filter_var($v, FILTER_VALIDATE_INT, $std_int_filter);
}



// password handling
// get a new salt - 8 hexadecimal characters long
// current PHP installations should not exceed 8 characters
// on dechex( mt_rand() )
// but we future proof it anyway with substr()
function getPasswordSalt()
{
	return substr( str_pad( dechex( mt_rand() ), 8, '0', STR_PAD_LEFT ), -8 );
}

// calculate the hash from a salt and a password
function getPasswordHash( $salt, $password )
{
    return $salt . ( hash( 'sha1', $salt . $password ) );
}

// compare a password to a hash
function comparePassword( $password, $hash )
{
    $salt = substr( $hash, 0, 8 );
    return $hash == getPasswordHash( $salt, $password );
}

function RandomPassword()
{
  $words = array('butter', 'dust', 'freeze', 'bunny', 'over', 'under', 'step', 'base', 'fruit',
	'sam', 'wet', 'water', 'apple', 'slip', 'frog', 'brat', 'pick', 'fly', 'zip', 'try', 'back');
	
  $pass1 = $words[ rand(0, count($words) - 1) ];
  $pass2 = $words[ rand(0, count($words) - 1) ];
  
  while ( $pass2 == $pass1 )
  {
	  $pass2 = $words[ rand(0, count($words) - 1) ];	
  }
  $pass3 = rand(1, 999);
  
  return $pass1 . $pass3 . $pass2;
}

function GetStoreID( $ownerKey )
{
	$sql = 'SELECT id FROM stores WHERE ownerkey="' . $ownerKey . '"';
	$result = run_mysql_query( $sql );
	if ( mysql_num_rows( $result ) == 1 )
	{
		$row = mysql_fetch_assoc( $result );
		return $row['id'];
	}
	else return 0;
}

function isValidGuid($guid)
{
	return !empty($guid) && preg_match('/^\{?[a-z0-9]{8}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{12}\}?$/', $guid);
}


// Credit functions ---------------

function GetCredit( $custKey, $storeID )
{
	$sql = 'SELECT balance FROM credits WHERE (custkey="' . $custKey . '") AND (storeid=' . $storeID . ')';
	$result = run_mysql_query( $sql );
	if ( mysql_num_rows( $result ) == 1 )
	{
		$row = mysql_fetch_assoc( $result );
		return $row['balance'];
	}
	else
	{
		return 0;
	}
}

function SetCredit( $custKey, $custName, $storeID, $newBalance )
{
	$sql = <<<SQL
INSERT INTO credits VALUES ("$custKey", "$custName", $storeID, $newBalance)
  ON DUPLICATE KEY UPDATE balance=$newBalance;
SQL;
	$result = run_mysql_query( $sql );
	return $result;
}

function ChangeCredit( $custKey, $storeID, $newBalance )
{
	$sql = <<< SQL
UPDATE credits SET balance = $newBalance
  WHERE (custkey="$custKey") AND (storeid=$storeID);
SQL;

	$result = run_mysql_query( $sql );
	return $result;
}

function AddCredit( $custKey, $custName, $storeID, $amount )
{
	$balance = 0;
	
	$sql = <<<SQL
INSERT INTO credits VALUES ( "$custKey", "$custName", $storeID, $amount )
  ON DUPLICATE KEY UPDATE balance = balance + $amount;
SQL;

	$result = run_mysql_query( $sql );
	if ( $result )
	{
		$balance = GetCredit( $custKey, $storeID );
	}
	
	return $balance;
}


// Region functions ----------------------

function CleanRegion( $region )
{
	// region names have a global coordinate tacked onto them, in parens
	$paren = strpos( $region, '(' );
	if ( $paren )
		$region = substr( $region, 0, $paren - 1 );
	return trim( $region );
}

function WholeNumber( &$num )
{
	$num = substr($num, 0, strpos($num, '.') );
}

function CleanPosition( $pos )
{
	$parts =  explode( ', ', trim($pos, '()') );
	array_walk( $parts, 'WholeNumber' );
	return implode('/', $parts );
}



// Product subscription functions ------------------------
function AddProductSubscription( $ownerKey, $productCode, $productVersion )
{
	$sql = <<<SQL
INSERT INTO subscriptions
VALUES ("$ownerKey", "$productCode", $productVersion, NOW() )
ON DUPLICATE KEY UPDATE version=$productVersion
SQL;
	
	$result = run_mysql_query( $sql );
	return $result;
}



// Messenger functions --------------------------------

function EraseRecipients( $storeID )
{
  $sql = "DELETE FROM recipients WHERE storeid=$storeID;";
  run_mysql_query( $sql );
}

function MessageDateRange( $params )
{
  $dateLow = strtotime( $params['datelow'] );
  $dateHigh = strtotime( $params['datehigh'] );
  
  if ( $dateLow > 0 && $dateHigh > 0 )
  {
    // ensure they're in the proper order
    if ( $dateLow > $dateHigh )
    {
      $temp = $dateLow;
      $dateLow = $dateHigh;
      $dateHigh = $temp;
    }
  }
  
  return array($dateLow, $dateHigh);
}

function MessageNumberRange( $numLow, $numHigh )
{
  // make sure both are numbers, and >= zero
  $numLow = max( 0, intval( $numLow ) );
  $numHigh = max( 0, intval( $numHigh ) );

  if ( $numLow > $numHigh && $numHigh > 0 )
  {
    $temp = $numLow;
    $numLow = $numHigh;
    $numHigh = $temp;
  }
  
  return array($numLow, $numHigh);
}

function CreateRecipientSQL( $storeID, $params )
{
  // here we create the SQL based on the type of query specified
  $sql = '';
  
  $querytype = $params['querytype'];
  $columns = "$storeID,";
  $table = "";
  $conditions = array();
  $extra = "";
  
  // create SQL for "I" (item) query type
  if ( $querytype == 'I' )
  {
    $table .= 'sales';
    $columns .= 'custkey,recipkey';
    
    $item = str_replace( '*', '%', $params['item'] );
    $conditions[] = '(item LIKE "' . $item . '")';
    $extra = 'GROUP BY custkey,recipkey';
  }
  
  // create SQL for "S" (spending) query type
  if ( $querytype == 'S' )
  {
    $table .= 'sales';
    $columns .= 'custkey,""';
    
    list($spendLow, $spendHigh) = MessageNumberRange($params['spendlow'], $params['spendhigh']);
    
    // the HAVING clause (if present) will be one of these:
    // a) HAVING SUM(cost) > min
    // b) HAVING SUM(cost) < max
    // c) HAVING SUM(cost) BETWEEN min,max
    $having = "";

    if ( $spendLow > 0 && $spendHigh == 0 )
      $having = ">= $spendLow";
    
    if ( $spendLow == 0 && $spendHigh > 0 )
      $having = "<= $spendHigh";
      
    if ( $spendLow > 0 && $spendHigh > 0 )
      $having = "BETWEEN $spendLow AND $spendHigh";
      
    if ( $having )
      $extra = "GROUP BY custkey HAVING (SUM(cost) $having)";
  }
  
  // create SQL for "C" (credit) query type
  if ( $querytype == 'C' )
  {
    $columns .= 'custkey,""';
    $table .= 'credits';
    
    list($creditLow, $creditHigh) = MessageNumberRange($params['creditlow'], $params['credithigh']);
    $conditions[] = "(balance>=$creditLow)";
    if ( $creditHigh )
      $conditions[] = "(balance<=$creditHigh)";
  }
  
  // do we need to add a date range?
  if ( in_array( $querytype, array('I', 'S') ) )
  {
    list( $dateLow, $dateHigh ) = MessageDateRange( $params );
    
    if ( $dateLow )
      $conditions[] = "(date>=$dateLow)";
    if ( $dateHigh )
      $conditions[] = "(date<=$dateHigh)";
  }
  
  if ( $table )
  {
    $conditions[] = "(storeid=$storeID)";
    $count = count($conditions);
    if ( $count )
    {
      $sql = "SELECT $columns FROM $table WHERE ";
      
      for ( $i = 0; $i < $count; $i++ )
      {
        $sql .= $conditions[$i];
        if ( $i < $count - 1 ) $sql .= ' AND ';
      }
      
      if ( $extra )
        $sql .= ' ' . $extra;
    }
  }
  
  return $sql;
}

function CreateRecipientList( $storeID )
{
  // first get rid of any existing entries
  EraseRecipients( $storeID );
  
  // load the messenger spec
  $sql = "SELECT * FROM messenger WHERE storeid=$storeID LIMIT 1;";
  $result = run_mysql_query( $sql );
  $params = mysql_fetch_assoc( $result );
  
  // return false if there's no query defined yet
  if ( !in_array( $params['querytype'], array('I', 'S', 'C') ) )
    return FALSE;
  
  // create the SQL for this recipient list
  $sql = 'INSERT INTO recipients ' . CreateRecipientSQL( $storeID, $params );
  
  $result = run_mysql_query(  $sql );
  return mysql_affected_rows();
}

function ValidMessengerQuery( $storeID )
{
  // load the messenger spec
  $sql = "SELECT * FROM messenger WHERE storeid=$storeID LIMIT 1;";
  $result = run_mysql_query( $sql );
  $params = mysql_fetch_assoc( $result );
  
  // must be a valid query type
  $sql = CreateRecipientSQL( $storeID, $params );
  
  return $sql;
}

