<?php

require_once('../inc/e2v_system.php');

// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our known commands
define('CMD_LOOKUP', 'lookup');		// check to see if this user is registered
define('CMD_REGISTER', 'register');		// create the user and a store
define('CMD_RESET', 'reset');		// reset the password
define('CMD_SUBSCRIBE', 'sub');		// add product subscription

// command must be recognized
$command = strtolower( filter_var($_POST["command"], FILTER_SANITIZE_STRING) );
if ( !in_array( $command, array(CMD_LOOKUP, CMD_REGISTER, CMD_RESET, CMD_SUBSCRIBE) ) )
{
	print( 'Unknown command: ' . $command );
	exit;
}

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();

$ownerKey = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'], FILTER_SANITIZE_STRING);
$ownerName = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'], FILTER_SANITIZE_STRING);

// validate that they're good
if ( (strlen($ownerKey) == 0) || (strlen($ownerName) == 0) )
{
	E2VError( 'Invalid arguments' );	
	exit;
}

$storeID = GetStoreID( $ownerKey );
	
$resp = array();

// handle check
if ( $command == CMD_LOOKUP )
{
	$resp[FIELD_STATUS] = STATUS_OK;
	$resp[FIELD_STOREID] = $storeID;
	LSLReply( $resp );
	exit;
}

// handle register ...
if ( $command == CMD_REGISTER )
{
	// special return value for already signed up
	if ( $storeID != 0 )
	{
		$resp[FIELD_STATUS] = STATUS_REG;
		$resp[FIELD_STOREID] = $storeID;
		LSLReply( $resp );
		exit;
	}
	
	$password = RandomPassword();
	$hash = getPasswordHash( getPasswordSalt(), $password );
	$now = time();
	
	// create the record
	$sql = <<<SQL
INSERT INTO owners 
	VALUES ("$ownerKey", "$ownerName", "$hash", "", $now)
SQL;
	  
	$result = run_mysql_query( $sql );
	if ( mysql_affected_rows() == 0 )
	{
		E2VError( mysql_error() );
		exit;
	}
	
	// send this back
	$resp[FIELD_PASSWORD] = $password;
	  
	// next we create a store for them  
	
	$sql = <<<SQL
INSERT INTO stores 
 VALUES (0, "$ownerKey", "My Store", $now, 0, 0, 0)
SQL;
		  
	$result = run_mysql_query( $sql );
	if ( mysql_affected_rows() == 0 )
	{
		E2VError( mysql_error() );
		exit;
	}
	  
	// otherwise we're done	
	$resp[FIELD_STATUS] = STATUS_OK;
	$resp[FIELD_STOREID] = mysql_insert_id();
	LSLReply( $resp );
	exit;
}

// handle the reset command
if ( $command == CMD_RESET )
{
	// create a new password
	$password = RandomPassword();
	$hash = getPasswordHash( getPasswordSalt(), $password );
	
	$sql = 'UPDATE owners SET password="' . $hash .'" WHERE ownerkey="' . $ownerKey . '"';
	$result = run_mysql_query( $sql );
	if ( mysql_affected_rows() == 0 )
	{
		E2VError( mysql_error() );
		exit;
	}
	
	// otherwise
	$resp[FIELD_STATUS] = STATUS_OK;
	$resp[FIELD_PASSWORD] = $password;
	LSLReply( $resp );
	exit;
}

// CMD_SUBSCRIBE
// add/update a product subscription
if ( $command == CMD_SUBSCRIBE )
{
	$version = $_POST['ver'];
	
	if ( AddProductSubscription( $ownerKey, 'e2v-3-base', $version ) )
	{
		$resp[FIELD_STATUS] = STATUS_OK;
	}
	else
	{
		$resp[FIELD_STATUS] = STATUS_ERR;
		$resp[FIELD_ERROR] = mysql_error();
	}

	LSLReply( $resp );	
	exit;
}

