<?php

require_once('../inc/e2v_system.php');


// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}


define('CMD_ADDCREDIT', 'addcredit');
define('CMD_DEDCREDIT', 'dedcredit');
define('CMD_GETCREDIT', 'getcredit');
define('CMD_SETCREDIT', 'setcredit');


$command = $_POST['command'];
if ( !in_array( $command, array(CMD_ADDCREDIT, CMD_DEDCREDIT, CMD_GETCREDIT, CMD_SETCREDIT) ) )
{
	print 'Unknown command: ' . $command;
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();

$ownerKey = $_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'];
$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	E2VError('You are not a registered store owner.');
	exit;
}

$custKey = $_POST['custkey'];
if ( strlen($custKey) == 0 )
{
	print 'Invalid arguments.';
	exit;
}

// all commands require that we start with the customer's current balance
$balance = GetCredit( $custKey, $storeID );

// CMD_GETCREDIT
if ( $command == CMD_GETCREDIT )
{
	print $balance;
	exit;
}

// CMD_ADDCREDIT
if ( $command == CMD_ADDCREDIT )
{
	// this command requires a name, since we might be creating a new record
	$custName = rawurldecode( $_POST['custname'] );
	$amount = CleanInt('amount');
	
	if ( strlen( $custName ) && ( $amount > 0 ) )
	{
		$newBalance = $balance + $amount;
		SetCredit( $custKey, $custName, $storeID, $newBalance );
		print $newBalance;
		exit;
	}
	else
	{
		print 'Invalid arguments.';
		exit;
	}
}

// CMD_SETCREDIT
if ( $command == CMD_SETCREDIT )
{
	// this command requires a name, since we might be creating a new record
	$custName = rawurldecode( $_POST['custname'] );
	$amount = CleanInt('amount');
	
	if ( strlen( $custName ) && ( $amount >= 0 ) )
	{
		SetCredit( $custKey, $custName, $storeID, $amount );
		print $amount;
		exit;
	}
	else
	{
		print 'Invalid arguments.';
		exit;
	}
}

// CMD_DEDCREDIT
if ( $command == CMD_DEDCREDIT )
{
	// This command assumes that a record already exists, so no name
	// is required
	$amount = CleanInt('amount');
	
	if ( $amount > 0 )
	{
		$newBalance = $balance - $amount;
		if ( $newBalance >= 0 )
		{
			ChangeCredit( $custKey, $storeID, $newBalance );
			print $newBalance;
		}
		else
		{
			print 'Invalid amount.';
		}
		exit;
	}
	else
	{
		print 'Invalid arguments.';
		exit;
	}
}

