<?php

require_once('../inc/e2v_system.php');

// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}

// our known commands
define('CMD_REGISTER', 'register');	  	// register a new card
define('CMD_STATUS', 'status');	  	 	// get a card's status
define('CMD_INFO', 'info');	  	 		// report on a card's data for the owner
define('CMD_REDEEM', 'redeem');   		// redeem this card for store credit

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();

// command must be recognized
$command = strtolower( $_POST["command"] );
if ( !in_array( $command, array(CMD_REGISTER, CMD_STATUS, CMD_INFO, CMD_REDEEM) ) )
{
	E2VError( 'Unknown command' );
	exit;
}

// commands must come from a valid owner
$ownerKey = $_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'];

$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	E2VError('You are not a current user of the E2V Vendor system.');
	exit;
}


// expected fields
$cardID = $_POST['id'];

// response
$resp = array();

// card register
if ( $command == CMD_REGISTER )
{
	$amount = intval( $_POST['amount'] );
	$custKey = $_POST['custkey'];
	$custName = rawurldecode( $_POST['custname'] );
  $payment = intval( $_POST['payment'] );
	
	$sql = <<<SQL
INSERT INTO gcards (storeid,cardid,buydate,amount,buyerkey,buyername)
  VALUES ($storeID, "$cardID", NOW(), $amount, "$custKey","$custName");
SQL;
	
	$result = run_mysql_query( $sql );
	if ( $result )
	{
		$resp[FIELD_STATUS] = STATUS_OK;
    
    // record the transaction
    if ( $payment == 0 ) $payment = $amount; // in case this isn't sent with older scripts
    $region = CleanRegion( $_SERVER['HTTP_X_SECONDLIFE_REGION'] );
    $date = time();
    
    $sql = <<<SQL
INSERT INTO sales 
 VALUES (0, $storeID, "$region", $date, "$custKey", "$custName", "Gift Card", "L", $payment, 0, NULL, NULL)
SQL;

    $result = run_mysql_query( $sql );
    
	}
	else
	{
		E2VError( mysql_error() );
		exit;
	}
	
	LSLReply( $resp );
	exit;
}

// card status
if ( $command == CMD_STATUS )
{
	$sql = <<<SQL
SELECT amount,redeemdate FROM gcards
  WHERE (storeid=$storeID) AND (cardid="$cardID")	
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_num_rows( $result ) == 1 )
	{
		$row = mysql_fetch_assoc( $result );
		$balance = intval( $row['amount'] );
		
		// if the redeemdate field is non-null, then the card has been redeemed
		if ( !is_null( $row['redeemdate'] ) )
			$balance = 0;
			
		$resp[FIELD_STATUS] = STATUS_OK;
		$resp[FIELD_BALANCE] = $balance;
	}
	else
	{
		// might not be at the right store!
		$resp[FIELD_STATUS] = STATUS_OK;
		$resp[FIELD_BALANCE] = -1;
	}
	
	LSLReply( $resp );
	exit;
	
}

// ----- INFO --------
if ( $command == CMD_INFO )
{
	$sql = <<<SQL
SELECT * FROM gcards
  WHERE (storeid=$storeID) AND (cardid="$cardID")	
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_num_rows( $result ) == 1 )
	{
		$row = mysql_fetch_assoc( $result );
		$report = "Card info:\n";
		$report .= 'Card ID: ' . $row['cardid'] . "\n";
		$report .= 'Purchased: ' . $row['buydate'] . "\n";
		$report .= 'Amount: L$' . $row['amount'] . "\n";
		$report .= 'Buyer: ' . $row['buyername'] . "\n";
		$report .= 'Redeemed: ' . $row['redeemdate'] . "\n";
		$report .= 'By: ' . $row['redeemname'] . "\n";
		
		print $report;
		exit;
	}
	else
	{
		print 'not found.';
		exit;
	}
}


// ------ REDEEM ------------
if ( $command == CMD_REDEEM )
{
	$custKey = $_POST['custkey'];
	$custName = rawurldecode( $_POST['custname'] );

	// first we make sure the card isn't already redeemed
	$sql = <<<SQL
SELECT amount,redeemdate FROM gcards
  WHERE (storeid=$storeID) AND (cardid="$cardID");	
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_num_rows( $result ) == 1 )
	{
		$row = mysql_fetch_assoc($result);
		$amount = $row['amount'];
		
		// has it already been redeemed?
		if ( is_null($row['redeemdate']) )
		{
			// update this record with the current info
			$sql = <<<SQL
			  UPDATE gcards 
			    SET redeemdate=NOW(),redeemkey="$custKey",redeemname="$custName"
				WHERE (storeid=$storeID) AND (cardid="$cardID");
SQL;

			$result = run_mysql_query( $sql );
			if ( mysql_affected_rows() == 1 )
			{
				// add this amount to the user's credit
				$balance = AddCredit($custKey, $custName, $storeID, $amount);
				$resp[FIELD_STATUS] = STATUS_OK;
				$resp[FIELD_BALANCE] = $balance;
			}
			else
			{
				$resp[FIELD_STATUS] = STATUS_ERR;
				$resp[FIELD_ERROR] = 'Unable to update card record. Please contact customer service.';
			}
		}
		else
		{
			$resp[FIELD_STATUS] = STATUS_ERR;
			$resp[FIELD_ERROR] = 'This card has already been redeemed.';
		}
	}
	else
	{
		// not found is an internal error
		$resp[FIELD_STATUS] = STATUS_ERR;
		$resp[FIELD_ERROR] = 'The info for this card was not found. Please contact customer support for help.';
	}

	LSLReply( $resp );
	exit;	
}

