<?php

define('CMD_REGISTER', 'register'); // make sure the user has a row in the messenger table
define('CMD_QUERY', 'query'); // perform query and return row count
define('CMD_GETPAGE', 'getpage'); // get page of UUIDs

define('PAGE_SIZE', 10); // number of uuids returned per page

// support functions
function ReplyStatus( $status )
{
  print json_encode( array('status' => $status) );
}

function ReplyOK()
{
  ReplyStatus('ok');
}

function ReplyError( $errmsg )
{
  print json_encode( array('err' => $errmsg) );
}


// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

require_once('../inc/e2v_system.php');

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}

$command = $_POST['command'];
if ( !in_array( $command, array(CMD_REGISTER, CMD_QUERY, CMD_GETPAGE) ) )
{
	ReplyError( 'Unknown command: ' . $command );
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();


$ownerKey = $_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'];
$objectKey = $_SERVER['HTTP_X_SECONDLIFE_OBJECT_KEY'];
$partnerKey = isset($_POST['partnerkey']) ? $_POST['partnerkey'] : "";

if ($partnerKey) $storeID = GetStoreID($partnerKey);
else $storeID = GetStoreID($ownerKey);

// general response array
$resp = array();


// CMD_REGISTER
if ($command == CMD_REGISTER)
{
	// we'll need the store ID for this lookup
	if ($storeID == 0)
	{
		ReplyError('Customer record could not be located.');
		exit;
	}

  // create the row
  $sql = <<<SQL
INSERT IGNORE INTO messenger (storeid)
VALUES ($storeID)
SQL;

  $result = run_mysql_query( $sql );
  if ( mysql_errno() != 0 ) ReplyError( mysql_error() );
  else 
  {
    // if we didn't insert anything, then we're already a user, and can
    // just continue. 
    $resp['status'] = 'ok';
    if ( mysql_affected_rows() > 0 ) $resp['new'] = 1;
    print json_encode( $resp );
  }
  
  exit;
}


// CMD_QUERY
// Run the user's query, but return only a count
if ( $command == CMD_QUERY )
{
  if ( ValidMessengerQuery( $storeID ) )
  {
    $total = CreateRecipientList( $storeID );
    $pages = max( 1, floor($total / PAGE_SIZE) );
    if ( ($pages * PAGE_SIZE) < $total )
      $pages++;
    
    $resp['total'] = $total;
    $resp['pages'] = $pages;
  }
  else
  {
    $resp['err'] = 'The query defined on the Messenger page is incomplete, or finds zero recipients.';
  }
  
  print json_encode( $resp );
  exit;
}


// CMD_GETPAGE
// Get a page of UUIDs
if ( $command == CMD_GETPAGE )
{
  $page = CleanInt('page') - 1;
  $offset = $page * PAGE_SIZE;
  $pageSize = PAGE_SIZE;
    
  $sql = <<<SQL
SELECT custkey,recipkey
FROM recipients
WHERE storeid=$storeID
LIMIT $offset,$pageSize
SQL;

  $uuids = array();
  $result = run_mysql_query( $sql );
  while ( $row = mysql_fetch_assoc($result) )
  {
    if ( $row['recipkey'] ) $uuids[] = $row['recipkey'];
    else $uuids[] = $row['custkey'];
  }

  print json_encode( $uuids );
  exit;
}
