<?php

require_once('../inc/e2v_system.php');

define('CMD_REGISTER', 'register');
define('CMD_GETURL', 'geturl');
define('CMD_GETURL2', 'geturl2');
define('CMD_GETADMIN', 'getadmin'); // requires admin password, too

// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}

$command = $_POST['command'];
if ( !in_array( $command, array(CMD_REGISTER, CMD_GETURL, CMD_GETADMIN, CMD_GETURL2) ) )
{
	print 'Unknown command: ' . $command;
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();

$ownerKey = $_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'];
$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	E2VError('You are not a registered store owner.');
	exit;
}

// geturl2 - get both primary and backup urls
if ( $command == CMD_GETURL2 )
{
	$sql = <<<SQL
SELECT url,burl FROM servers
	WHERE storeid=$storeID;
SQL;

	$result = run_mysql_query( $sql );
	if ( $row = mysql_fetch_assoc( $result ) )
	{
		$resp = array();
		$resp[FIELD_URL_MAIN] = rawurlencode( $row['url'] );
		$resp[FIELD_URL_BACKUP] = rawurlencode( $row['burl'] );
		LSLReply( $resp );
	}
	else
	{
		E2VError( STATUS_NOTFOUND );
	}
	
	exit;	
}

// handle simple lookup
if ( $command == CMD_GETURL )
{
	$sql = <<<SQL
SELECT url FROM servers
	WHERE storeid=$storeID;
SQL;

	$result = run_mysql_query( $sql );
	if ( $row = mysql_fetch_assoc( $result ) )
	{
		print rawurlencode( $row['url'] );
	}
	else
	{
		E2VError( STATUS_NOTFOUND );
	}
	
	exit;	
}



// get admin info
if ( $command == CMD_GETADMIN )
{
	// make sure admin password is present
	if ( $_POST['apw'] != '29$fipple' )
	{
		exit;
	}

	// allow replacing the store id	
	$storeID = $_POST['storeid'];

	$sql = <<<SQL
SELECT uuid,UNIX_TIMESTAMP(updated) AS update,url,region,pos
  WHERE storeid=$storeID;
SQL;

	$result = run_mysql_query( $sql );
	if ( $row = mysql_fetch_assoc( $result ) )
	{
		$resp = array();
		$resp[FIELD_URL] = rawurlencode( $row['url'] );
		$resp[FIELD_UUID] = $row['uuid'];
		$resp[FIELD_DATE] = $row['update'];
		$resp[FIELD_LOCATION] = rawurlencode( $row['region'] . '/' . $row['pos'] );
		LSLReply( $resp );
	}
	else
	{
		E2VError( STATUS_NOTFOUND );
	}

	exit;	
}


// CMD_REGISTER
if ( $command == CMD_REGISTER )
{
	$uuid = filter_var($_SERVER['HTTP_X_SECONDLIFE_OBJECT_KEY'], FILTER_SANITIZE_STRING);	
	$region = CleanRegion( filter_var($_SERVER['HTTP_X_SECONDLIFE_REGION'], FILTER_SANITIZE_STRING) );
	$pos = CleanPosition( filter_var($_SERVER['HTTP_X_SECONDLIFE_LOCAL_POSITION'], FILTER_SANITIZE_STRING) );
	$url = rawurldecode($_POST['url']);
	$backup = $_POST['backup'];

	if ( $backup )
	{
		$sql = <<<SQL
INSERT INTO servers (storeid,burl,buuid,bregion,bpos,bupdated)
  VALUES ($storeID, "$url", "$uuid", "$region", "$pos", NOW())
  ON DUPLICATE KEY UPDATE burl="$url",buuid="$uuid",bregion="$region",bpos="$pos",bupdated=NOW();
SQL;
		
	}
	else
	{
		$sql = <<<SQL
INSERT INTO servers (storeid,url,uuid,region,pos,updated)
  VALUES ($storeID, "$url", "$uuid", "$region", "$pos", NOW())
  ON DUPLICATE KEY UPDATE url="$url",uuid="$uuid",region="$region",pos="$pos",updated=NOW();
SQL;
		
	}
	
	$result = run_mysql_query( $sql );
	if ( $result )
	{
		print 'ok';
	}
	else
	{
		$error = 'error: (' . mysql_errno() . ') ' . mysql_error();
		E2VError( $error );
	}
		
	exit;
}