<?php
require_once('../inc/e2v_utils.php');

// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != 'xy1223' )
{
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our known commands
define('CMD_CHECK', 'check');		// check caller's versions
define('CMD_ADD', 'add');		// add a subscription for caller
define('CMD_GETURL', 'geturl');		// get product server URL
define('CMD_SETURL', 'seturl');		// set product server URL

// added for messenger
define('CMD_VERSION', 'ver'); // check just a version, without subscription info

// versions table
$VersionTable = array(
  'e2v-3-base' => array(
		'version' => 6,
		'description' => 'E2V-3 Base Product'), 
	'e2v-3-mv' => array(
	  'version' => 1,
		'description' => 'E2V-3 MultiVendor' ),
	'e2v-3-msg' => array(
		'version' => 3,
		'description' => 'E2V-3 Messenger'),
  'wishlists' => array(
    'version' => 3,
    'uuid' => 'c86f02f9-d99b-2dd0-507f-586da38170b1',
    'description' => 'E2 WishLists')
	);


// make sure there's a valid command
$command = strtolower( filter_var($_POST['command'], FILTER_SANITIZE_STRING) );
if ( !in_array( $command, array(CMD_CHECK, CMD_ADD, CMD_GETURL, CMD_SETURL, CMD_VERSION) ) )
{
	E2VError( 'Unknown command: ' . $command );
	exit;
}

// must find valid SL fields
$ownerKey = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'], FILTER_SANITIZE_STRING);
$ownerName = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'], FILTER_SANITIZE_STRING);

// validate that they're good
if ( (strlen($ownerKey) == 0) || (strlen($ownerName) == 0) )
{
	E2VError( 'Invalid arguments' );	
	exit;
}


// our required files
require_once('../inc/e2v_db.php');

// clean up all posted variables
DBConnect();
CleanPost();

// global response array
$resp = array();



// CMD_CHECK
// Return the list of updated products (if any)
if ( $command == CMD_CHECK )
{
	// grab all the customer's subscriptions, and compare them against
	// the latest product versions
	
	$sql = <<<SQL
SELECT productcode,version 
FROM subscriptions
WHERE ownerkey="$ownerKey";
SQL;
	
	$result = run_mysql_query( $sql );
	while ( $row = mysql_fetch_assoc($result) ) 
	{
		$productCode = $row['productcode'];
		$productInfo = $VersionTable[ $productCode ];
		if ( isset($productInfo) )
		{
			$userVersion = $row['version'];
			if ( $userVersion <> $productInfo['version'] )
				$resp[] = $productCode . '|' . $productInfo['description'];
		}
	}
	
	if ( count( $resp ) )
		print implode( ',', $resp );
	
	exit;
}


// CMD_GETURL
// return the product server's URL
if ( $command == CMD_GETURL )
{
	$result = run_mysql_query( 'SELECT url FROM subserver WHERE id=1' );
	if ( $row = mysql_fetch_assoc( $result ) )
	  print $row['url'];
		
	exit;
}

// CMD_SETURL
// Set the product server's URL
if ( $command == CMD_SETURL )
{
	$url = rawurldecode( $_POST['url'] );
	
	$sql = <<<SQL
INSERT INTO subserver VALUES (1, "$url")
ON DUPLICATE KEY UPDATE url="$url";
SQL;

	$result = run_mysql_query( $sql );
	if ( $result ) print 'ok';
	else print mysql_error();

	exit;
}


// CMD_ADD
// Add a subscription for this user
if ( $command == CMD_ADD )
{
	$code = $_POST['code'];
	$version = $_POST['version'];
	
	if ( AddProductSubscription( $ownerKey, $code, $version ) ) print 'ok';
	else print mysql_error();
	
	exit;
}


// CMD_VERSION
// Just return a version number without any subscription checks
if ( $command == CMD_VERSION )
{
  // what product are they asking about?
  $product = $_POST['product'];
  $productInfo = $VersionTable[ $product ];
	if ( isset($productInfo) )
  {
		$resp['ver'] = $productInfo['version'];
    if ( $productInfo['uuid'] )
      $resp['uuid'] = $productInfo['uuid'];
  }
  
  print json_encode( $resp );
  exit;  
}




