<?php

require_once('../inc/e2v_system.php');

// an initial check that the post seems to be coming from SL...
$shard = $_SERVER['HTTP_X_SECONDLIFE_SHARD'];
if ( $shard != 'Production' )
{
	exit;
}

// check that the password is valid
if ( $_POST['pw'] != OBJECT_PASSWORD )
{
	exit;
}

header("content-type: text/plain; charset=utf-8");
date_default_timezone_set('America/Los_Angeles');

// our known commands
define('CMD_CLICK', 'click');	  		// someone clicked
define('CMD_RESET', 'reset');			// owner is resetting
define('CMD_COUNT', 'count');			// check count

//----
// command must be recognized
$command = strtolower( filter_var($_POST["command"], FILTER_SANITIZE_STRING) );
if ( !in_array( $command, array(CMD_CLICK, CMD_RESET, CMD_COUNT) ) )
{
	print( 'Unknown command: ' . $command );
	exit;
}

// our required files
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// clean up all posted variables
DBConnect();
CleanPost();

$ownerKey = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_KEY'], FILTER_SANITIZE_STRING);
$ownerName = filter_var($_SERVER['HTTP_X_SECONDLIFE_OWNER_NAME'], FILTER_SANITIZE_STRING);

// validate that they're good
if ( (strlen($ownerKey) == 0) || (strlen($ownerName) == 0) )
{
	E2VError( 'Invalid arguments' );	
	exit;
}

$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	E2VError( 'You are not a current user of the E2V Vendor system.' );
	exit;
}

$resp = array();

$listID = $_POST['listid'];


// ------ CLICK --------------

if ( $command == CMD_CLICK )
{
	$custKey = $_POST['custkey'];
	$custName = rawurldecode( $_POST['custname'] );
	$amount = $_POST['amount'];
	
	// here we use the ON DUPLICATE KEY syntax to kill two birds with one stone:
	// the row is inserted if it doesn't exist, and updated if it does already.
	// the difference is detected by the affected rows count, 1 for insert,
	// 2 for update. 
	$sql = <<<SQL
INSERT INTO vipcredit2 VALUES ($storeID, $listID, "$custKey", 1)
  ON DUPLICATE KEY UPDATE added=added+1;
SQL;

	$result = run_mysql_query( $sql );
	
	if ( mysql_errno() != 0 )
	{
		reply_error( mysql_error() );
		exit;
	}
	
	$resp[FIELD_STATUS] = STATUS_OK;
	
	if ( mysql_affected_rows() == 2 )
	{
		// updating an existing row, so they're already added
		$resp[FIELD_REWARDED] = 0;
	}
	else
	{
		$resp[FIELD_REWARDED] = $amount;
		// also need to add the credit, and get the balance
		$resp[FIELD_BALANCE] = AddCredit( $custKey, $custName, $storeID, $amount);
	}

	LSLReply( $resp );
	exit;	
}


// ------ RESET --------
if ( $command == CMD_RESET )
{
	$sql = <<<SQL
DELETE FROM vipcredit2
  WHERE (storeid=$storeID) AND (listid=$listID);	
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_errno() )
	{
		print mysql_error();
	}
	else
	{
		print "ok";
	}
	exit;
}

// ------ COUNT --------
if ( $command == CMD_COUNT )
{
	$sql = <<<SQL
SELECT COUNT(*) as clicked FROM vipcredit2
  WHERE (storeid=$storeID) AND (listid=$listID);	
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_errno() )
	{
		print 'Error: ' . mysql_error();
	}
	else
	{
		$row = mysql_fetch_assoc( $result );
		print 'Count = ' . $row['clicked'];
	}
	exit;
}



