<?php

// make sure we're authorized to be loading this file
session_start();
$storeID = $_SESSION['storeid'];
$ownerKey = $_SESSION['ownerkey'];

if ( !isset($storeID) ) {
	exit;
}

require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

// commands we handle...
define('CMD_CHANGEPW', 'changepw');
define('CMD_RENAMESTORE', 'renamestore');


DBConnect();
CleanPost();

$resp = array();

$command = strtolower( filter_var($_POST['command'], FILTER_SANITIZE_STRING) );
if ( !in_array( $command, array(CMD_CHANGEPW, CMD_RENAMESTORE) ) )
{
	$resp[FIELD_STATUS] = STATUS_ERR;
	$resp[FIELD_ERROR] = 'Unrecognized command.';
	print json_encode( $resp );
	exit;
}

$resp = array();

// CMD_CHANGEPW
// Change the user's password
if ( $command == CMD_CHANGEPW )
{
	$resp[FIELD_STATUS] = STATUS_ERR;
	
	$curPW = $_POST['curpw'];
	$newPW = $_POST['newpw'];
	
	// the current password has to be correct
	$sql = <<<SQL
SELECT password FROM owners WHERE ownerkey="$ownerKey";	
SQL;

	$result = run_mysql_query( $sql );
	if ( $result )
	{
		$row = mysql_fetch_assoc( $result );
		
		// if the passwords match ...
		if ( comparePassword( $curPW, $row['password'] ) )
		{
			// create and store a new hash
		  $hash = getPasswordHash( getPasswordSalt(), $newPW );
			$sql = <<<SQL
UPDATE owners
SET password="$hash"
WHERE ownerkey="$ownerKey";
SQL;
			$result = run_mysql_query( $sql );
			if ( mysql_affected_rows() == 1 )
			{
				$resp[FIELD_STATUS] = STATUS_OK;
			}
			else
			{
				$resp[FIELD_ERROR] = 'Unable to update password. Please try again.';
			}
			
		}
		else
		{
			$resp[FIELD_ERROR] = 'Your current password was incorrect.';
		}
	}
	else
	{
		$resp[FIELD_ERROR] = 'User lookup failed.';
	}

	print json_encode( $resp );
	exit;	
	
}


// CMD_RENAMESTORE
// Change the store name
if ( $command == CMD_RENAMESTORE )
{
	$resp[FIELD_STATUS] = STATUS_ERR;
	
	$newName = $_POST['storename'];

	$sql = <<<SQL
UPDATE stores 
SET name="$newName"
WHERE id=$storeID;
SQL;

	$result = run_mysql_query( $sql );
	if ( mysql_affected_rows() == 1 )
	{
		$resp[FIELD_STATUS] = STATUS_OK;
	}
	else
	{
		$resp[FIELD_ERROR] = 'Unable to update password. Please try again.';
	}

	print json_encode( $resp );
	exit;
	
}

