<?php

date_default_timezone_set('America/Los_Angeles');

// make sure we're authorized to be loading this file
session_start();
$storeID = $_SESSION['storeid'];
$ownerKey = $_SESSION['ownerkey'];

if ( !isset($storeID) ) {
	exit;
}

require_once('../inc/e2v_system.php');

require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');
require_once('../inc/Datatables.php');

$datatables = new Datatables();

// mySQL config
$config = array(
  'username' => DB_USER,
	'password' => DB_PASSWORD,
	'database' => DB_NAME,
	'hostname' => DB_HOST);

$datatables->connect( $config );

$datatables
->select('buydate,amount,buyerkey,buyername,cardid,redeemdate,redeemkey,redeemname')
->from('gcards')
->where('storeid=', $storeID)
->edit_column('buyername', '$1', 'userlink(buyername,buyerkey)')
->edit_column('redeemname', '$1', 'userlink(redeemname,redeemkey)')
->edit_column('buydate', '$1', 'dformat(buydate)')
->edit_column('redeemdate', '$1', 'dformat(redeemdate)')
->unset_column('buyerkey')
->unset_column('redeemkey');

echo $datatables->generate();

// =================

function userlink($custName, $custKey)
{
	$link = '<a class="userlink" href="' . $custKey . '">' . $custName . '</a>';
  return $link;
}


function dformat( $d )
{
  if ( $d )
  {
    $pDate = strtotime( $d );
    return date(DATE_FORMAT, $pDate);
  }
  else return "";
}

