<?php
date_default_timezone_set('America/Los_Angeles');

// make sure we're authorized to be loading this file
session_start();
$storeID = $_SESSION['storeid'];
$ownerKey = $_SESSION['ownerkey'];

if ( !isset($storeID) ) {
	exit;
}

require_once('../inc/e2v_system.php');

require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');
require_once('../inc/Datatables.php');

$datatables = new Datatables();

// mySQL config
$config = array(
  'username' => DB_USER,
	'password' => DB_PASSWORD,
	'database' => DB_NAME,
	'hostname' => DB_HOST);
	
$datatables->connect( $config );

$datatables
->select('date,region,item,custkey,custname,recipkey,recipname,cost,paytype,reward')
->from('sales')
->where('storeid=', $storeID)
->edit_column('custname', '$1', 'userlink(custname,custkey,recipname,recipkey)')
->edit_column('date', '$1', 'dformat(date)')
->unset_column('custkey')
->unset_column('recipkey')
->unset_column('recipname');

echo $datatables->generate();

// =================

function userlink($custName, $custKey, $recipName, $recipKey)
{
	$link = '<a class="userlink" href="' . $custKey . '">' . $custName . '</a>';
	if ( strlen($recipName) )
		$link .= '<br />for: <a class="userlink" href="' . $recipKey . '">' . $recipName . '</a>';
  return $link;
}


function dformat( $d )
{
	return date(DATE_FORMAT, $d);
}

