<?php

$hasForms = true;
$crumbs = array('main','annual-summary');

include_once('user-auth.php');
include_once('page-header.php');
include_once('../inc/e2v_db.php');
include_once('../inc/e2v_utils.php');

DBConnect();
CleanPost();

// see if there's a year param
$year = isset($_GET['year']) ? (int)$_GET['year'] : 0;
if ($year < 2007 || $year > date("Y")) {
  $year = date("Y");
}

$startDate = mktime(0, 0, 0, 1, 1, $year);
$endDate = mktime(23, 59, 59, 12, 31, $year);

?>

<div class="grid-50 prefix-25 suffix-25">

  <div id="ranges">
    <label for="year">Select report year:</label>
    <select id="year" name="year">
<?php

for ($y = 2010; $y <= 2014; $y++) {
  $mod = ($y == $year) ? ' selected' : '';
  $html = '<option value="' . $y . '"' . $mod . '>';
  $html .= $y . '</option>';
  echo $html;
}

?>    
    </select>

  </div>

  <article>
    <header><h4>Cash Sales for the Year <?php echo $year; ?></h4></header>
    <section>
      <table class="sales-table">
        <tr>
          <td width="20%">Total:</td>
          <td>
<?php

$sql = <<<SQL
SELECT SUM(cost) AS total
FROM sales
WHERE (storeid=$storeID) AND (date>=$startDate) AND (date<=$endDate);
SQL;

  $result = run_mysql_query($sql);
  $row = mysql_fetch_assoc($result);
  echo 'L$' . number_format($row['total']);

?>
          </td>
        </tr>
      </table>
    </section>
  </article>
</div>

<div class="grid-50 prefix-25 suffix-25">
  <article>
    <header><h4>Top Customers for the Year <?php echo $year; ?></h4></header>
    <section>
      <table class="sales-table">
        <thead>
          <tr>
            <th align="left">Customer</th>
            <th align="right">Spent</th>
          </tr>
        </thead>
        <tbody>
<?php

  $sql = <<<SQL
SELECT custname, SUM(cost) AS total
FROM sales
WHERE (storeid=$storeID) AND (date>=$startDate) AND (date<=$endDate)
GROUP BY custkey
ORDER BY total DESC
LIMIT 10;
SQL;

  $result = run_mysql_query($sql);
  while ($row = mysql_fetch_assoc($result)) {
    $html = "<tr><td>{$row['custname']}</td>";
    $html .= "<td align='right'>L$" . number_format($row['total']) . "</td></tr>\n";
    echo $html;
  }

?>        
        </tbody>
      </table>
    </section>
  </article>
</div>



<script>
$(function () {

  $("#year").on('change', function() {
    var value = this.value;
    window.location = 'annual-summary.php?year=' + value;
    return false;
  });

});
</script>

<?php
include_once('page-footer.php');

