<?php

$hasForms = true;
$crumbs = array('main','change-password');

include_once('user-auth.php');
include_once('page-header.php');

?>

<div class="grid-60 prefix-20 suffix-20">

  <div>
    <form id="changepw_form" class="std-form">
      <fieldset>
        <legend>Change Password</legend>
        <div>
        	<label class="field" for="cur_pw">Current password:</label>
          <input autofocus type="password" id="cur_pw" name="cur_pw" placeholder="current password" maxlength="40">
        </div>
        <div>
        	<label class="field" for="new_pw">New password:</label>
          <input type="password" id="new_pw" name="new_pw" placeholder="new password" maxlength="40">
        </div>
        <div>
        	<label class="field" for="conf_pw">Confirm password:</label>
          <input type="password" id="conf_pw" name="conf_pw" placeholder="confirm password" maxlength="40">
        </div>
        <br />
        <button id="change_btn">Change Password</button>
        <div id="result_msg" class="resultmsg">Your password has been updated.</div>
      </fieldset>
    </form>
    
  </div>

</div>

<script>

$(function() {
	
	$("#result_msg").hide();

	$("#changepw_form").validate({
		rules: {
			cur_pw: {
				required: true,
				minlength: 2,
				maxlength: 40
			},
			new_pw: {
				required: true,
				minlength: 2,
				maxlength: 40
			},
			conf_pw: {
				required: true,
				minlength: 2,
				maxlength: 40,
				equalTo: "#new_pw"
			},
		}
	});
	
	$("#change_btn").button({
		icons: { primary: "ui-icon-key" }
	});
	
	$("#change_btn").click(function(e) {
		if ( $("#changepw_form").validate().form() )
		{
			var params = {
				"command": "changepw",
				"curpw": $("#cur_pw").val(),
				"newpw": $("#new_pw").val()
			}
			
			// send the request to the server
			$.post( "_accounts.php", params, function(data) {

					if ( data["_status"] == "ok" )
					{
						$("#result_msg").removeClass("msg-error").addClass("msg-success");
						$("#result_msg").text( "Your password has been updated." );
						
						$("#cur_pw").val("");
						$("#cur_pw").focus();
						$("#new_pw").val("");
						$("#conf_pw").val("");
					}
					else
					{
						$("#result_msg").removeClass("msg-success").addClass("msg-error");
						$("#result_msg").text( data["_error"] );
					}
					
					// show the message
					$("#result_msg").show().delay(2000).fadeOut(2000);
					
			}, "json");
					
		}
		
		return false;
  });
	
	
});

</script>


<?php
include_once('page-footer.php');
