<?php

$hasForms = true;
$dataTables = true;
$crumbs = array('main','cust-details');

include_once('user-auth.php');
include_once('page-header.php');
include_once('../inc/e2v_db.php');

// uuid passed on the URL
$uuid = $_GET['u'];

?>

<div class="grid-50">
  <article>
    <header><h4>Find Customer</h4></header>
    <section>
      <table>
        <tr>
          <td nowrap="nowrap" width="10%"><label for="custname">Customer name:</label></td>
          <td nowrap="nowrap" width="50%" valign="top">
            <input id="custname" type="text" autofocus value="" placeholder="Enter avatar name" />
          </td>
        </tr>
      </table>
    </section>
  </article>
</div>

<div class="grid-50">
  <article>
    <header><h4>How to Use This Form</h4></header>
    <section>
      <ul>
        <li>Type at least 3 characters in the Customer name box at left and 
        a list of customer names will be shown.</li>
        <li>Only <em>existing</em> customers will be listed.</li>
      </ul>
    </section>
  </article>
</div>

<div class="grid-100">&nbsp;</div>

<div class="grid-100">
  <article>
    <header><h4>Summary</h4></header>
    <section id="summary_content">
      <table id="summary">
        <tbody>
          <tr>
            <td nowrap="nowrap" width="5%">Customer name:</td>
            <td nowrap="nowrap" width="5%" id="avname"></td>
            <td id="avlink" class="align-left"></td>
          </tr>
          <tr>
            <td nowrap="nowrap">Cash spent to date:</td>
            <td id="cash_spent"></td>
            <td></td>
          </tr>
          <tr>
            <td nowrap="nowrap">Credit spent to date:</td>
            <td id="credit_spent"></td>
            <td></td>
          </tr>
          <tr>
            <td nowrap="nowrap">Credit earned to date:</td>
            <td id="credit_earned"></td>
            <td></td>
          </tr>
          <tr>
            <td nowrap="nowrap">Current credit balance:</td>
            <td nowrap="nowrap" colspan="2">
              <form id="credit_form">
                <input type="text" id="credit_balance" value="" />
                <button id="credit_btn">Update Balance</button>
              </form>
            </td>
          </tr>
        </tbody>
      </table>    

      <div id="msg_div" class="ui-widget ui-state-highlight ui-corner-all">
        <div id="msg_text" class="ui-widget-content ui-corner-all" style="padding: 5px;">
        </div>
      </div>
    </section>
  
	</article>
</div>

<div class="grid-100">&nbsp;</div>

<div class="grid-100">
  <article>
    <header><h4>Transaction History</h4></header>
    <section id="transaction_content">
      <table id="transactions" class="dataTable">
        <thead>
          <tr>
            <th class="align-left">Date</th>
						<th class="align-left">Region</th>            
            <th class="align-left">Item</th>
            <th class="align-left">Recipient</th>
            <th class="align-left">Price</th>
            <th class="align-left">Method</th>
            <th class="align-left">Credit</th>
            <th class="align-left">&nbsp;</th>
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    </section>
  </article>
</div>


<script>

// state vars
var targetUUID = "";
var lastCredit = 0;
var theTable = null;

function populateAvatar( data )
{
	$("#avname").html( "<strong>" + data["name"] + "</strong>" );
	$("#avlink").html( data["link"] );
}

function populateFinancials(data)
{
	$("#cash_spent").text("L$" + data["L"]);
	$("#credit_spent").text("L$" + data["C"]);
	$("#credit_earned").text("L$" + data['earned']);
	
	lastCredit = data['balance'];
	$("#credit_balance").val( lastCredit );
}

function populateTransactions( data )
{
	var html = "";
	
	// clear the table
	$("#transactions tbody tr").remove();
	
	// add rows
	if ( data.length == 0 )
	{
		html = '<tr><td colspan="5">There are no transactions recorded for this person.</td></tr>';
		$("#transactions tbody").append(html);
	}
	else
	{
		$.each( data, function(index) {
			var cells = data[index];
			theTable.fnAddData( cells );
		});
	}
	
}

function requestCustomerData()
{
	// clear the table
	theTable.fnClearTable();
	
	var params = {
		command: "summary",
		uuid: targetUUID
	}
	
	$.post( "_customers.php", params, function(data) {
		
		if ( data["_status"] == "ok" )
		{
			// populate the page
			populateAvatar( data["avatar"] );
			populateFinancials( data["financials"] );
			populateTransactions( data["transactions"] );
			
			$("#summary_content").show();
			$("#transaction_content").show();
		}
		else
		{
			showError( data["_error"] );
		}
	}, "json");
	
}


$( function() {

	$("#summary_content").hide();
	$("#transaction_content").hide();
	$("#msg_div").hide();

	
	// set up autocomplete widget
	var acConfig = {
		"source": function(request, response) {
			$.ajax({
				url: "_customers.php",
				type: "POST",
				dataType: "json",
				data: {
					command: "lookup",
					term: request.term
				},
				success: function(data) {
					response(data);
				},
				error: function() {
					response([]);
				}
			});
		},
		"select": function(event, ui) {
			event.preventDefault();
			$(this).val("");
			targetUUID = ui.item.uuid;
			if ( targetUUID != "" )
			  requestCustomerData();
		},
		minLength: 3
	};
	$("#custname").autocomplete(acConfig);


	// initialize the data table
	theTable = $("#transactions").dataTable({
		"aaSorting": [ [0, "desc"] ],
		"aoColumns": [ 
			{ "bSearchable": false },
			null, null, 
			{ "bSearchable": false },
			{ "bSearchable": false },
			{ "bSearchable": false },
			{ "bSearchable": false },
			{ "bSearchable": false }],
		"bAutoWidth": false,
		"sPaginationType": "full_numbers",
		"bJQueryUI": true
	});



	// handle changing the credit amount
	$("#credit_btn").click( function() {
		
		  var s = $("#credit_balance").val();
			
			// can't be blank
			if ( s.length == 0 )
			{
				alert("Can't use blank. Type 0 if you want to erase this person's balance.");
				return false;
			}
			
			// but must be a number
			var balance = parseInt( s );
			if ( balance < 0 || isNaN(balance) )
			{
				alert("Please use positive whole numbers, or 0");
				return false;
			}
			
			// was there any change?
			if ( parseInt(lastCredit) == balance )
			{
				alert("There was no change to the value.");
				return false;
			}
			
			// just for sanity, the UUID has to be present
			if ( targetUUID.length == 0 )
			{
				alert("An internal error has occurred, please refresh the page.");
				return false;
			}
			
			// lastly we'll confirm the change
			var targetName = $("#avname").text();
			if ( confirm("Set credit balance for " + targetName + " to L$" + balance + " now?") )
			{
				var params = {
					"command": "setcredit",
					"uuid": targetUUID,
					"name": targetName,
					"balance": balance
				}
				
				// send the request to the server
				$.post( "_customers.php", params, function(data) {
					
					if ( data["_status"] == "ok" )
					{
						$("#msg_div").removeClass("ui-state-error").addClass("ui-state-highlight");
						$("#msg_text").text( "Credit balance has been updated." );
					}
					else
					{
						$("#msg_div").removeClass("ui-state-highlight").addClass("ui-state-error");
						$("#msg_text").text( data["_error"] );
					}
					
					// show the message
					$("#msg_div").show().delay(2000).fadeOut(1000);
					
				}, "json");
				
			}
			
			return false;
	});

	// handle the redeliver links
	$("body").on( "click", ".redlink", function() {
		
		var data = $(this).data("transid");
		var fields = data.split( '-', 2 );
		
		if ( fields.length != 2 )
		{
			window.alert("internal data error, please report!");
			return false;
		}
		
		if ( window.confirm("Are you sure you want to redeliver this item?") ) {
			
			var params = {
				transid: fields[0],
				storeid: "<?php print $storeID; ?>",
				ownerkey: "<?php print $ownerKey; ?>",
				customerkey: targetUUID,
				checksum: fields[1] 
				}			
			
			$.post('../redeliver/_dodeliver.php', params, function(data) {
				if ( data['status'] == "ok" ) {
					window.alert("Redelivery requested.");
				}
				else {
					window.alert( data["error"] );					
				}
			}, "json");
			
		}
		
		return false;
	});
	
<?php
  if ( isset($uuid) )
	{
?>	
		targetUUID = "<?php print $uuid ?>";
		requestCustomerData();
<?php
	}
?>
	

	
});

</script>

<?php
include_once('page-footer.php');

