<?php

$hasForms = true;
$crumbs = array('main','item-sales');

include_once('user-auth.php');
include_once('page-header.php');
include_once('../inc/e2v_db.php');
include_once('../inc/e2v_utils.php');

$rangeNames = array("Today", "This Month", "Last Month", "This Year" );

// grab the form fields
$itemName = isset($_POST["itemname"]) ? $_POST["itemname"] : "";
$dateRange = isset( $_POST["range"] ) ? intval( $_POST["range"] ) : 1;

?>

<div class="grid-50">
  <article>
    <header><h4>Item</h4></header>
    <section>
      <form id="params" action="item-sales.php" method="POST">
      <table>
        <tr>
          <td nowrap="nowrap" width="10%"><label for="itemname">Item name:</label></td>
          <td nowrap="nowrap" width="50%" valign="top">
            <input id="itemname" type="text" autofocus name="itemname" placeholder="Enter item name"
            value="<?php echo $itemName; ?>"/>
          </td>
        </tr>
        <tr>
          <td>Date range:</td>
          <td id="ranges" style="font-size: 80%;">
            <input type="radio" id="today" name="range" value="0" <?php if ($dateRange==0) echo 'checked="checked"'; ?> >
              <label for="today">Today</label>
            </input>
            <input type="radio" id="thismonth" name="range" value="1" <?php if ($dateRange==1) echo 'checked="checked"'; ?> >
              <label for="thismonth">This Month</label>
            </input>
            <input type="radio" id="lastmonth" name="range" value="2" <?php if ($dateRange==2) echo 'checked="checked"'; ?> >
              <label for="lastmonth">Last Month</label>
            </input>
            <input type="radio" id="thisyear" name="range" value="3" <?php if ($dateRange==3) echo 'checked="checked"'; ?> >
              <label for="thisyear">This Year</label>
            </input>
          </td>
        </tr>

        <tr>
          <td colspan="2">&nbsp;</td>
        </tr>

        <tr>
          <td>&nbsp;</td>
          <td><button id="srchbtn" type="button">Search</button></td>
        </tr>
      </table>
      </form>
    </section>
  </article>
</div>

<div class="grid-50">
  <article>
    <header><h4>How to Use This Form</h4></header>
    <section>
      <ul>
        <li>Enter some or all of an item name you'd like to report on.</li>
        <li>You may use the wildcard character "*" to specify multiple items.</li>
      </ul>
      <p>Examples:</p>
      <ul>
        <li><strong>Blue Shirt</strong><br />Will report <em>only</em> on items named "Blue Shirt"</li>
        <li><strong>* Shirt</strong><br />Will report on products that end with the word "Shirt"</li>
        <li><strong>*</strong><br />Will report on all products sold</li>
      </ul>
    </section>
  </article>
</div>

<div class="grid-100">&nbsp;</div>

<?php if ( $itemName ) {

DBConnect();
CleanPost();

// re-fetch this after cleaning the post
$itemName = $_POST["itemname"];
$itemQuery = str_replace( '*', '%', $itemName );

// figure out the date ranges
switch ( $dateRange )
{
  case 0:
    $dateLow = mktime(0, 0, 0);
    $dateHigh = time();
    break;
  case 1:
    $dateLow = mktime(0, 0, 0, date('m'), 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, date('m') + 1, 0, date('Y') );
    break;
  case 2:
    $dateLow = mktime(0, 0, 0, date('m') - 1, 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, date('m'), 0, date('Y') );
    break;
  case 3:
    $dateLow = mktime(0, 0, 0, 1, 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, 12, 31, date('Y') );
    break;
}

// create the query
$sql = <<<SQL
SELECT item,SUM(cost) AS itemtotal
FROM sales
WHERE (storeid=$storeID) AND (item LIKE "$itemQuery")
AND (date>=$dateLow) AND (date<=$dateHigh)
GROUP BY item
ORDER BY item DESC
SQL;

// and execute it
$result = run_mysql_query( $sql );

?>

<div class="grid-100">
  <article id="sales_article">
    <header><h4>Sales for Matching Items</h4></header>
    <section>
      <table>
        <tbody>
          <tr>
            <td>Item name:</td>
            <td><?php echo $itemName; ?></td>
          </tr>
          <tr>
            <td>Date range:</td>
            <td><?php echo $rangeNames[ $dateRange ]; ?></td>
          </tr>
        </tbody>
      </table>

      <table class="sales-table">
        <thead>
          <tr>
            <th width="50%" align="left">Item Name</th>
            <th align="left">Sales</th>
            <th width="40%" align="left">&nbsp;</th>
          </tr>
        </thead>
        <tbody>
<?php

 $grandTotal = 0;

 // fetch the rows
 while ( $row = mysql_fetch_assoc($result) )
 {
   $html = array();

   $html[] = "<tr>";
   $html[] = "  <td>{$row['item']}</td>";

   $itemTotal = $row['itemtotal'];
   $grandTotal += $itemTotal;

   $html[] = "  <td align='right'>L\${$itemTotal}</td>";
   $html[] = "  <td>&nbsp;</td>";
   $html[] = "</tr>";

   echo implode( $html, PHP_EOL );
 }

 // a blank row...
 echo "<tr><td colspan=\"3\">&nbsp;</tr>", PHP_EOL;

 // and the total
 echo "<tr><td><strong>Total:</strong></td><td align=\"right\"><strong>L\${$grandTotal}</strong></td><td></td></tr>", PHP_EOL;

?>
        </tbody>
      </table>

    </section>

	</article>
</div>

<?php } ?>

<div class="grid-100">&nbsp;</div>


<script>

$( function() {

  $("#ranges").buttonset();

	// handle changing the credit amount
	$("#credit_btn").click( function() {


			return false;
	});

  $("#params").submit( function() {
    var item = $("#itemname").val();
    if ( item.trim().length == 0 )
    {
      alert("Please enter an item name.");
      return false;
    }
  });

  $("#srchbtn").click( function() {
    $("#params").submit();
  });

});

</script>

<?php
include_once('page-footer.php');

