<?php

$hasForms = true;
$crumbs = array('main','messenger');

include_once('user-auth.php');
include_once('page-header.php');
include_once('../inc/e2v_db.php');

// see if we have an existing record of saved data
DBConnect();

$sql = "SELECT * FROM messenger WHERE storeid=$storeID LIMIT 1";
$result = run_mysql_query( $sql );
$state = mysql_fetch_assoc( $result );

$initialPage = 0;
if ( $state['querytype'] == "S" ) $initialPage = 1;
if ( $state['querytype'] == "C" ) $initialPage = 2;


?>

<div class="grid-100">

  <div id="tabs">
    <ul>
      <li><a href="#byitems">By Items</a></li>
      <li><a href="#byspending">By Spending</a></li>
      <li><a href="#bybalance">By Credit Balance</a></li>
    </ul>
    
    <div id="byitems">
      <p>Select customers who purchased:<br />
        <input name="selected-item" id="selected-item" type="text" size="40"
         value="<?php print $state['item']; ?>" />
        <button id="help-button">Help me Pick Items</button>
      </p>
    </div>
    
    <div id="byspending">
      <p>Select customers who have spent</p>
      <p>at least L$<input id="spendlow" type="text" size="10" value="<?php print $state['spendlow']; ?>" /> 
      but not 
      over L$<input id="spendhigh" type="text" size="10" value="<?php print $state['spendhigh']; ?>" />
      </p>
      <p>Hints:</p>
      <ul>
        <li>set both values to 0 to select customers who haven't spent any
        L$ in the date range below.</li>
        <li>Leave the 2nd value 0 to mean any amount over the first value.</li>
      </ul>
          
    </div>
    
    <div id="bybalance">
      <p>Select customers with <em>current</em> store credit balance of</p>
      <p>at least L$<input id="creditlow" type="text" size="10" value="<?php print $state['creditlow']; ?>" /> but not 
      over L$<input id="credithigh" type="text" size="10" value="<?php print $state['credithigh']; ?>" /></p>
    </div>
  </div>

  <div id="date-inputs">
    <p>Restrict date range (does not apply to credit balances):</p>
    <p>From <input type="text" id="datelow" value="<?php print $state['datelow']; ?>" />
    &nbsp;to&nbsp;<input type="text" id="datehigh" value="<?php print $state['datehigh']; ?>" /></p>
    <p><strong>Note:</strong> date format is YYYY-MM-DD</p>
  </div>

<?php if ( intval($state['storeid']) > 0 ) { ?>

  <p style="border-top: 2px solid #999; margin-top: 2em; padding-top: 1em;">
  <button id="save-settings">Save These Settings</button>
  </p>
  
  <p id="save-confirmation">Settings have been saved.</p>

<?php } else { ?>
  
  <p class="msgr-info"><strong>Note:</strong> The Messenger feature requires that you purchase the
  [E2V] Messenger Add-on product from Marketplace. You can find out more information
  about the Messenger feature, as well as links to purchase it, 
  <a href="#">by clicking here.</a></p>
<?php } ?>

</div> <!-- grid-100 -->


<!-- Item helper -->
<div id="item-helper" title="Select Item">
  <form id="item-form">
    <fieldset style="border: 0;">
      <label for="item-name">Item name:</label>
      <input name="item-name" id="item-name" type="text" />
      <button id="search-button">Search</button>
      <p>Hints: you can use * to indicate a wildcard in the item name.</p>
    </fieldset>
  </form>
  <div id="search-results">&nbsp;</div>
</div>


<script>

var minCalDate = new Date(2009, 0, 1);
var initialPage = <?php print $initialPage; ?>;


function getQueryType()
{
  var active = $( "#tabs" ).tabs( "option", "active" );
  switch( active )
  {
    case 0:
      return "I";
    case 1:
      return "S";
    case 2:
      return "C";
    default:
      return "?";
  }
}

function getFormParams( commandstr )
{
  var data = {
    command: commandstr,
    querytype: getQueryType(),
    itemname: $("#selected-item").val(),
    spendlow: $("#spendlow").val(), 
    spendhigh: $("#spendhigh").val(),
    creditlow: $("#creditlow").val(),
    credithigh: $("#credithigh").val(),
    datelow: $("#datelow").val(),
    datehigh: $("#datehigh").val()
  }
    
  return data;
}

function doAutoFocus()
{
  var active = $( "#tabs" ).tabs( "option", "active" );
  switch( active )
  {
    case 0:
      $("#date-inputs").show();
      $("#selected-item").focus();
      break;
    case 1:
      $("#date-inputs").show();
      $("#spendlow").focus();
      break;
    case 2:
      $("#date-inputs").hide();
      $("#creditlow").focus();
      break;
  }
}

$( function() {

  // init page controls
	$("#tabs").tabs({
    activate: function( event, ui ) {
      doAutoFocus();
    }
  });
  
  $("#datelow").datepicker({
    dateFormat: "yy-mm-dd",
    minDate: minCalDate,
    maxDate: 0,
    changeMonth: true,
    changeYear: true
  });
  
  $("#datehigh").datepicker({
    dateFormat: "yy-mm-dd",
    minDate: minCalDate,
    maxDate: 0,
    changeMonth: true,
    changeYear: true
  });
  
  $("#item-helper").dialog({
    autoOpen: false,
    height: 500,
    width: 650,
    modal: true,
    buttons: {
      "Use Item Name": function () {
        var itemName = $("#item-name").val();
        $("#selected-item").val( itemName );
        $(this).dialog( "close" );
        
      },
      Cancel: function() {
        $(this).dialog( "close" );
      }
    }
  });
  
  $("#help-button")
    .button()
    .click(function() {
      $("#item-helper").dialog("open");
    });
  
  $("#search-button").click( function() {
    
    var query = $("#item-name").val();
    
    if ( query.length == 0 )
    {
      $("#search-results").html("Name cannot be blank.");
      return;
    }
    
    if ( query == "*" )
    {
      $("#search-results").html("Your search returns <strong>all</strong> your products.");
      return;
    }
    
    // otherwise there's an actual query string
  	var params = {
      command: "isearch",
  		q: query
  	}
	
  	$.post( "_msgr-utils.php", params, function(data) {
  		
  		if ( data["_status"] == "ok" )
  		{
        var items = data["items"];
        var length = items.length, item = null;
       
        var html;
        if ( length == 0 )
        {
          html = "<p>There were no matching items found.</p>";
        }
        else
        {
          html = "<p>Your search returned the following items:</p>";  
          html += "<ul>";
          
          for (var i = 0; i < length; i++ )
            html += "<li>" + items[i] + "</li>";
          
          html += "</ul>";
        }
        
        $("#search-results").html( html );
  		}
  	}, "json");
    
  });
  
  $("#save-settings").click( function() {

    var params = getFormParams( "save" );

  	$.post( "_msgr-utils.php", params, function(data) {
      
      if ( data["_status"] != "ok" )
      {
        alert("Error: " + data["_error"] );
        alert(data["sql"]);
      }
      else
      {
        $("#save-confirmation").show().delay(1500).fadeOut(1000);
      }
      
  	}, "json");
    
  });

  $("#tabs").tabs({active: initialPage})
  doAutoFocus();
  
  $("#save-confirmation").hide();
  
});
  
</script>

<?php
include_once('page-footer.php');
