<?php
date_default_timezone_set('America/Los_Angeles');
?>

<!DOCTYPE HTML>
<html>
<head>
<meta charset="utf-8">

	<title>E2V Version 3</title>

	<link rel="stylesheet" type="text/css" href="css/unsemantic-grid-responsive.css" />
	<link rel="stylesheet" type="text/css" href="css/jquery-ui-1.10.0.custom.min.css" />
	<link rel="stylesheet" type="text/css" href="css/e2v-3.css" />

	<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
	<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.10.0/jquery-ui.min.js"></script>
<?php if ( isset($dataTables) ) { ?>
	<link rel="stylesheet" type="text/css" href="css/jquery.dataTables_themeroller.css" />
	<script type="text/javascript" src="js/jquery.dataTables.min.js"></script>
<?php } ?>

<?php if ( isset($hasForms) ) { ?>
	<script type="text/javascript" src="js/jquery.validate.min.js"></script>
  <script>
	  $( function() {
			$("button")
				.button()
				.click( function( event ) {
					event.preventDefault();
				});
		});
	</script>
<?php } ?>

</head>

<body>

<div class="grid-container">

  <div class="grid-100">
    <a href="index.php"><img src="images/e2v-3-logo-100x40.png" width="100" height="40"></a>
    <hr noshade="noshade">
<?php if ( isset($firstName) ) { ?>
		<p>Welcome, <?php print $firstName; ?>. (Store <?php print $storeID; ?>) <a href="logout.php">[logout]</a></p>
<?php } ?>    
  </div>

  
<?php if ( isset($crumbs) ) { ?>
  <div class="grid-100">
    <div id="crumbs-content">
    
<?php

$pageData = array(
	'main' => array( 'title' => 'Main menu', 'page' => 'index' ),
	'cust-details' => array( 'title' => 'Customer Details', 'page' => 'customer-details'),
	'messenger' => array( 'title' => 'Messenger', 'page' => 'messenger'),
	'change-password' => array( 'title' => 'Change Password', 'page' => 'change-password'),
	'change-store' => array( 'title' => 'Change Store Name', 'page' => 'change-store'),
	'recent-sales' => array( 'title' => 'Recent Sales', 'page' => 'recent-sales'),
	'top-sellers' => array( 'title' => 'Top Sellers', 'page' => 'top-sellers'),
	'trans-list' => array( 'title' => 'Transaction List', 'page' => 'trans-list'),
	'lim-qty' => array('title' => 'Limited Quantity Items', 'page' => 'limited-quantity'),
  'gcard-list' => array('title' => 'Gift Card List', 'page' => 'gcard-list'),
  'store-credit' => array('title' => 'Store Credit', 'page' => 'store-credit'),
  'item-sales' => array('title' => 'Item Sales', 'page' => 'item-sales'),
  'region-sales' => array('title' => 'Region Sales', 'page' => 'region-sales'),
  'annual-summary' => array('title' => 'Annual Summary', 'page' => 'annual-summary'),
);

$keys = array_keys($crumbs);
$last = end($keys);

foreach ( $crumbs as $index => $pageIdent )
{
	$caption = $pageData[$pageIdent]['title'];
	$linkPage = $pageData[$pageIdent]['page'] . '.php';
	
	if ( $index == $last )
	{
		// last item outputs only the caption, not as a link
		print $caption;
	}
	else
	{
		print '<a href="' . $linkPage . '">' . $caption . '</a> &raquo; ';
	}
	
}

?>    
  
    </div>
  </div>
<?php } ?>    
