<?php

$hasForms = true;
$crumbs = array('main','region-sales');

include_once('user-auth.php');
include_once('page-header.php');
include_once('../inc/e2v_db.php');
include_once('../inc/e2v_utils.php');

$rangeNames = array("Today", "This Month", "Last Month", "This Year" );

// grab the form fields
$region = isset($_POST["region"]) ? $_POST["region"] : "";
$region = htmlentities($region);
$dateRange = isset( $_POST["range"] ) ? intval( $_POST["range"] ) : 1;

?>

<div class="grid-50">
  <article>
    <header><h4>Item</h4></header>
    <section>
      <form id="params" action="region-sales.php" method="POST">
      <table>
        <tr>
          <td nowrap="nowrap" width="10%"><label for="region">Region:</label></td>
          <td nowrap="nowrap" width="50%" valign="top">
            <input id="region" type="text" autofocus name="region" placeholder="Enter region name" 
            value="<?php echo $region; ?>"/>
          </td>
        </tr>
        <tr>
          <td>Date range:</td>
          <td id="ranges" style="font-size: 80%;">
            <input type="radio" id="today" name="range" value="0" <?php if ($dateRange==0) echo 'checked="checked"'; ?> >
              <label for="today">Today</label>
            </input>
            <input type="radio" id="thismonth" name="range" value="1" <?php if ($dateRange==1) echo 'checked="checked"'; ?> >
              <label for="thismonth">This Month</label>
            </input>
            <input type="radio" id="lastmonth" name="range" value="2" <?php if ($dateRange==2) echo 'checked="checked"'; ?> >
              <label for="lastmonth">Last Month</label>
            </input>
            <input type="radio" id="thisyear" name="range" value="3" <?php if ($dateRange==3) echo 'checked="checked"'; ?> >
              <label for="thisyear">This Year</label>
            </input>
          </td>
        </tr>

        <tr>
          <td colspan="2">&nbsp;</td>
        </tr>
        
        <tr>
          <td>&nbsp;</td>
          <td><button id="srchbtn" type="button">Search</button></td>
        </tr>
      </table>
        <input type="hidden" name="formflag" value="1">
      </form>
    </section>
  </article>
</div>

<div class="grid-50">
  <article>
    <header><h4>How to Use This Form</h4></header>
    <section>
      <ul>
        <li>Enter the region name you'd like to report on.</li>
        <li>You may use the wildcard character "*".</li>
        <li>Leave the region blank to report on all regions</li>
      </ul>
    </section>
  </article>
</div>

<div class="grid-100">&nbsp;</div>

<?php if (isset($_POST["formflag"])) { 

DBConnect();
CleanPost();

// re-fetch this after cleaning the post
$region = htmlentities($_POST["region"]);
if ($region == "") {
  $region = "*";
}

$regionQuery = str_replace('*', '%', $region);

// figure out the date ranges
switch ( $dateRange )
{
  case 0:
    $dateLow = mktime(0, 0, 0);
    $dateHigh = mktime();
    break;
  case 1:
    $dateLow = mktime(0, 0, 0, date('m'), 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, date('m') + 1, 0, date('Y') );
    break;
  case 2:
    $dateLow = mktime(0, 0, 0, date('m') - 1, 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, date('m'), 0, date('Y') );
    break;
  case 3:
    $dateLow = mktime(0, 0, 0, 1, 1, date('Y') );
    $dateHigh = mktime(23, 59, 59, 12, 31, date('Y') );
    break;
}

// create the query 
$sql = <<<SQL
SELECT region,SUM(cost) AS totalsales
FROM sales
WHERE (storeid=$storeID) AND (region LIKE "$regionQuery") 
AND (date>=$dateLow) AND (date<=$dateHigh)
GROUP BY region
ORDER BY region DESC
SQL;

// and execute it
$result = run_mysql_query( $sql );

?>

<div class="grid-100">
  <article id="sales_article">
    <header><h4>Sales for Region(s)</h4></header>
    <section>
      <table>
        <tbody>
          <tr>
            <td>Region:</td>
            <td><?php echo $region; ?></td>
          </tr>
          <tr>
            <td>Date range:</td>
            <td><?php echo $rangeNames[ $dateRange ]; ?></td>
          </tr>
        </tbody>
      </table>
    
      <table class="sales-table">
        <thead>
          <tr>
            <th width="50%" align="left">Region</th>
            <th align="left">Sales</th>
            <th width="40%" align="left">&nbsp;</th>
          </tr>
        </thead>
        <tbody>
<?php

 $grandTotal = 0;
 
 // fetch the rows
 while ( $row = mysql_fetch_assoc($result) )
 {
   $html = array();
   
   $html[] = "<tr>";
   $html[] = "  <td>{$row['region']}</td>";
   
   $totalSales = $row['totalsales'];
   $grandTotal += $totalSales;
   
   $html[] = "  <td align='right'>L\${$totalSales}</td>";
   $html[] = "  <td>&nbsp;</td>";
   $html[] = "</tr>";
   
   echo implode( $html, PHP_EOL );
 }

 // a blank row...
 echo "<tr><td colspan=\"3\">&nbsp;</tr>", PHP_EOL;
 
 // and the total
 echo "<tr><td><strong>Total:</strong></td><td align=\"right\"><strong>L\${$grandTotal}</strong></td><td></td></tr>", PHP_EOL;

?>        
        </tbody>
      </table>    

    </section>
  
	</article>
</div>

<?php } ?>

<div class="grid-100">&nbsp;</div>


<script>

$( function() {

  $("#ranges").buttonset();
  
  $("#srchbtn").click( function() {
    $("#params").submit();
  });
	
});

</script>

<?php
include_once('page-footer.php');

