<?php

$dataTables = true;
$crumbs = array('main','trans-list');

include_once('user-auth.php');
include_once('page-header.php');
//include_once('../inc/e2v_db.php');

?>

<div class="grid-100">
  <article>
    <header><h4>Transaction List</h4></header>
    <section>
      <p><strong>Note:</strong> If you're looking for transactions for a particular customer, it's more efficient if you <a href="customer-details.php">go here instead</a>.</p>
    	<br />
    
      <table id="transactions" class="dataTable">
        <thead>
          <tr>
            <th class="align-left">Date</th>
						<th class="align-left">Region</th>            
            <th class="align-left">Item</th>
            <th class="align-left">Customer</th>
            <th class="align-left">Price</th>
            <th class="align-left">Method</th>
            <th class="align-left">Credit</th>
            <!--<th class="align-left"></th>-->
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    </section>
  </article>
</div>


<div class="grid-100">&nbsp;</div>



<script>

var theTable = null;

$(document).ready(function()
{
	
	// initialize the data table
	theTable = $("#transactions").dataTable({
		"aaSorting": [ [0, "desc"] ],
		"aoColumns": [ 
			{ "bSearchable": false },
			null, null, 
			{ "bSearchable": false },
			{ "bSearchable": false },
			{ "bSearchable": false },
			{ "bSearchable": false }],
		"bAutoWidth": false,
		"sPaginationType": "full_numbers",
		"bJQueryUI": true,
		"bProcessing": true,
		"bServerSide": true,
		"sAjaxSource": "_translist.php",
		"fnServerData" : function( sSource, aoData, fnCallback ) {
			
			$.ajax({
				"dataType" : "json",
				"type" : "POST",
				"url" : sSource,
				"data" : aoData,
				"success" : fnCallback
			});
			
		}
	});
	
	$("body").on( "click", ".userlink", function() {
		
		var uuid = $(this).attr('href');
		var url = "customer-details.php?u=" + uuid;
		window.location = url;
		
		return false;
	});
		
	
	
});
</script>

<?php
include_once('page-footer.php');


