<?php

require_once('../inc/e2v_system.php');
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

DBConnect();
CleanPost();

//		var params = {
//			transid: 
//			storeid: 
//			ownerkey: 
//			customerkey: 
//			checksum: 
//			}			

$transID = $_POST['transid'];
$storeID = $_POST['storeid'];
$ownerKey = $_POST['ownerkey'];
$customerKey = $_POST['customerkey'];
$checksum = $_POST['checksum'];

$resp = array();

// the transaction id must be a positive integer 
if ( !is_numeric( $transID ) || ($transID <= 0 ) )
{
	error('Invalid transaction ID');
	exit;
}

// go look up this record
$sql = <<<SQL
SELECT * 
FROM sales 
WHERE (id=$transID) AND (storeid=$storeID)
SQL;

$result = run_mysql_query($sql);

if ( mysql_num_rows($result) != 1 )
{
	error('Transaction not found');
	exit;
}

// get the row
$row = mysql_fetch_assoc( $result );

// now we can check out the checksum to make sure the request is valid

// the checksum is the 9th, 11th, 6th and 3rd characters of the hash of
// the ownerKey + customerKey + 'xx1332'
$hash = sha1( $ownerKey . $customerKey . OBJECT_PASSWORD );
$cs = substr($hash, 9, 1) . substr($hash, 11, 1) . substr($hash, 6, 1) . substr($hash, 3, 1);

if ( $checksum != $cs )
{
	error('Invalid checksum');
	exit;
}

// save the rest of these vars..
$customerName = $row['custname'];

$targetKey = isset($row['recipkey']) ? $row['recipkey'] : '';
if ( strlen($targetKey) == 0 ) $targetKey = $customerKey;

$targetName = isset($row['recipname']) ? $row['recipname'] : '';
if ( strlen($targetName) == 0 ) $targetName = $customerName;

$item = trim($row['item']);

// now we need the inventory server's URL
$url = '';

$sql = <<<SQL
SELECT url 
FROM servers
WHERE (storeid=$storeID)
SQL;

$result = run_mysql_query( $sql );
if ( $result )
{
	$row = mysql_fetch_assoc( $result );
	$url = $row['url'];
}

if ( $url )
{
	// make sure there's a slash on the end for SL
	$url .= '/';

	// we also need the store password
	$storePassword = sha1( 'e2v' . $ownerKey . 'e2v' );
	
	// put together all the params for the inventory server
	$params = $storePassword . '|' . $targetKey . '|' . rawurlencode( $item ) . '|1|100';
	
	$opts = array('http' =>
		array(
			'method'  => 'POST',
			'header'  => 'Content-type: application/x-www-form-urlencoded',
			'content' => $params
		)
	);

	$context  = stream_context_create($opts);
	$reply = file_get_contents($url, false, $context);
	
	if ($reply)
	{
		// signal we at least got a reply from the server
		$resp['status'] = 'ok';

		// see what the server said		
		$code = intval( $reply );
		$status = 'ok';

		if ( $code == -9 ) $status = 'Server too busy.';
		if ( $code == -2 ) $status = 'Invalid credentials'; // invalid store password!
		if ( $code == -1 ) $status = 'Invalid	call'; // badly formed params	
		
		$resp['svr_status'] = $status;
	}
	else
	{
		$resp['status'] = 'err';
	}
		
	print json_encode( $resp );
	exit;	
}
else
{
	error('Inventory server offline');
	exit;
}



// -----------------
function error( $msg )
{
	$r = array();
	$r['status'] = 'err';
	$r['error'] = $msg;
	print json_encode( $r );
}

/*

        string target_key = GetFieldValue( fields, "targetkey", "" );
        string target_name = llUnescapeURL( GetFieldValue( fields, "targetname", "" ) );
        string user_key = GetFieldValue( fields, "userkey", "" );
        string user_name = llUnescapeURL( GetFieldValue( fields, "username", "" ) );
        string item = llUnescapeURL( GetFieldValue( fields, "item", "" ) );
        integer redeliver = 0;
        if ( GetFieldValue( fields, "rdlvr", "" ) == "1" )
            redeliver = 1;



*/