<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Request Product Redelivery</title>

<link rel="stylesheet" type="text/css" href="customers.css" media="screen"/>
<script language="javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js"></script>

</head>

<body>

<?php

// ------------- support functions --------
function ErrorPage( $errCode )
{
?>
<p>We're sorry, but you've reached this page in error.</p>
<p>(Error code: <?php print $errCode; ?>)</p>
</body>
</html>
<?php	
}

function _isValidGuid($guid)
{
	return !empty($guid) && preg_match('/^\{?[a-z0-9]{8}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{12}\}?$/', $guid);
}


// --------- Main code ---------

// r - concatination of ownerKey + customerKey + checksum. 
$redeliver = $_GET['r'];

// stupid viewer2 codebase appends a ? onto the end of the URL!
if ( substr( $redeliver, -1 ) == '?' )
{
	$redeliver = substr( $redeliver, 0, -1 );
}

if ( strlen( $redeliver ) != 76 )
{
	ErrorPage(1);
	exit;
}

// break up the main param
$ownerKey = substr( $redeliver, 0, 36 );
$customerKey = substr( $redeliver, 36, 36 );
$checksum = substr( $redeliver, -4, 4 );

// validate the params so far
if ( !_isValidGuid( $ownerKey ) || !_isValidGuid( $customerKey ) )
{
	ErrorPage(2);
	exit;
}

require_once('../inc/e2v_system.php');

// the checksum is the 9th, 11th, 6th and 3rd characters of the hash of
// the ownerKey + customerKey + 'xx1332'
$hash = sha1( $ownerKey . $customerKey . OBJECT_PASSWORD );
$cs = substr($hash, 9, 1) . substr($hash, 11, 1) . substr($hash, 6, 1) . substr($hash, 3, 1);

if ( $checksum != $cs )
{
	ErrorPage(3);
	exit;
}

// p - page number (optional)
$page = intval( isset($_GET['p']) ? $_GET['p'] : 1 );
if ( $page <= 0 )
{
	ErrorPage(4);
	exit;
}

$pageSize = 10;

// since we've made it this far, we'll create a db connection and
// look up the owner to make sure they're valid
require_once('../inc/e2v_db.php');
require_once('../inc/e2v_utils.php');

DBConnect();

$storeID = GetStoreID( $ownerKey );
if ( $storeID == 0 )
{
	ErrorPage(5);
	exit;
}

// get the store name
$sql = "SELECT name FROM stores WHERE id=$storeID";
$result = run_mysql_query( $sql );
$row = mysql_fetch_assoc( $result );
$storeName = $row['name'];

$offset = ($page - 1) * $pageSize;

// now that we've made it this far, we can look up the transactions

$sql = <<<SQL
SELECT * 
FROM sales 
WHERE (storeid=$storeID) AND (custkey="$customerKey") AND (item != "GIFT CARD")
ORDER BY date DESC 
LIMIT $offset,$pageSize
SQL;

$result = run_mysql_query( $sql );

if ( mysql_num_rows($result) == 0 )
{
	print '<p>There were no transactions found for you at this store.</p>';
	exit;
}

?>

<div class="pagecontainer">

<h1><?php print $storeName; ?> Redeliveries</h1>
<h2>How to Re-deliver a Purchase</h2>
<p>Click on the name of the item that you would like re-delivered.</p>
<p>Purchases are listed with most recent purchases first. If the item you're looking for
was purchased before those listed, use the paging links to try the next page(s).</p>

<table>
  <thead>
    <th width="20%" nowrap="nowrap">Date</th>
    <th width="50%" nowrap="nowrap">Item Name</th>
    <th width="30%" nowrap="nowrap">Gift for</th>
  </thead>
  <tbody>

<?php

while ( $row = mysql_fetch_assoc($result) )
{
	$id = $row['id'];
	$recipName = $row['recipname'];// != NULL ? $row['recipname'] : '';
	$when = date(DATE_FORMAT, $row['date']);
	$item = htmlspecialchars($row['item']);
	$itemLink = '<a class="id_link" rel="' . $id . '" href="#">' . $item . '</a>';

	print "<tr><td>$when</td><td>$itemLink</td><td>$recipName</td></tr>";		
}

?>
  </tbody>
</table>

<?php

// now we'll decide if we need to page
$sql = <<<SQL
SELECT COUNT(*) AS total 
FROM sales 
WHERE (storeid=$storeID) AND (custKey="$customerKey") AND (item != "GIFT CARD");
SQL;

$result = run_mysql_query($sql);
$row = mysql_fetch_assoc($result);
$total = $row['total'];

$pageCount = ceil( $total / $pageSize );
print "<p>$total purchases. Page $page of $pageCount</p>";

// next/prev links
$baseURL = htmlspecialchars($_SERVER['PHP_SELF']) . '?r=' . $redeliver .'&p=';

// if there's a previous page...
if ( $page > 1 )
{
	print '<a href="' . $baseURL . ($page - 1) . '">&lt;&lt; Previous</a>&nbsp;&nbsp;';
}

// next
if ( $page < $pageCount )
{
	print '<a href="' . $baseURL . ($page + 1) . '">Next &gt;&gt;</a>&nbsp;&nbsp;';
}

print '</p>';

?>

</div>

<script language="javascript">

var url_params = {
	r: "<?php echo $redeliver; ?>",
	e: ""
}

$(document).ready( function() {
	
	$(".id_link").click( function() {
		
		var params = {
			transid: $(this).attr("rel"),
			storeid: "<?php print $storeID; ?>",
			ownerkey: "<?php print $ownerKey; ?>",
			customerkey: "<?php print $customerKey; ?>",
			checksum: "<?php echo $checksum; ?>" 
			}			
		
		$.post("_dodeliver.php", params, function(data) {
			
			if ( data['status'] == 'ok' )
			{
				if ( data['svr_status'] != 'ok' ) url_params.e = escape( data['svr_status'] );
				else url_params.e = "";
				
				var url = "completed.php?r=" + url_params.r + "&e=" + url_params.e;
				location = url;
				return false;
			}
			else
			{
				location = "error.php";
				return false;
			}
			
		}, "json");
		
		return false;
	});
});

</script>

</body>

</html>